package org.objectweb.fractal.bf.hdl.graph;

import jdsl.graph.api.Vertex;

/**
 * A pair of vertices. 
 *
 */
public class PairOfVertices
{

  Vertex v1, v2;
  
  /**
   * Constructor.
   * @param v1 the first vertex
   * @param v2 the second vertex
   */
  public PairOfVertices(Vertex v1, Vertex v2)
  {
    
    this.v1 = v1;
    this.v2 = v2;
    
  }

  /**
   * @see java.lang.Object#hashCode()
   */
  @Override
  public int hashCode()
  {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((v1 == null) ? 0 : v1.hashCode());
    result = prime * result + ((v2 == null) ? 0 : v2.hashCode());
    return result;
  }

  /**
   * @see java.lang.Object#toString()
   */
  @Override
  public String toString()
  {

    String vertex1Decoration = (String) v1.element();
    String vertex2Decoration = (String) v2.element();

    return vertex1Decoration + vertex2Decoration;
  }

  
  
  
  /**
   * @see java.lang.Object#equals(java.lang.Object)
   */
  @Override
  public boolean equals(Object obj)
  {
    if (this == obj)
      return true;
    if (obj == null)
      return false;

    final PairOfVertices other = (PairOfVertices) obj;
    if (v1 == null)
    {
      if (other.v1 != null)
        return false;
    }
    else if (!v1.equals(other.v1))
      return false;
    if (v2 == null)
    {
      if (other.v2 != null)
        return false;
    }
    else if (!v2.equals(other.v2))
      return false;
    return true;
  }

  public final Vertex getV1()
  {
    return v1;
  }

  public final Vertex getV2()
  {
    return v2;
  }

}