
package org.objectweb.fractal.bf.hdl.reader;

import java.io.File;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import org.xmlnetwork.NetML;

/**
 * Reader to import XML files compliant to to NetML XSD schema. The resulting {@link NetML} object
 * can be used to navigate the object graph.
 *
 */
public class NetMLReaderImpl implements NetMLReader
{

  private JAXBContext jc;

  public NetMLReaderImpl()
  {
    try
    {

      this.jc = JAXBContext.newInstance("org.xmlnetwork"); //see fractal-bf-hdl-model
    }
    catch (JAXBException e)
    {
      e.printStackTrace();
    }
  }

  /**
   * @see org.objectweb.fractal.bf.hdl.reader.NetMLReader#read(java.io.File)
   */
  public NetML read(File input)
  {

    NetML netml = null;

    try
    {
      Unmarshaller unmarshaller = jc.createUnmarshaller();
      netml = (NetML) unmarshaller.unmarshal(input);
    }
    catch (JAXBException e)
    {
      e.printStackTrace();
    }

    return netml;
  }

}
